<?php
    namespace Folha\Logic\Cadastros\SetupOrganizacao;

    use Geral\Entities\Filial;
    use HCM\Util\DateUtil;
    use \Geral\Util\Novocodigo;

    class CadastroFilial{
        const TABELA = 'FILIAL';
        private $Idcomparqxmlfil;
        private $Idconsorcfil;
        private $Nrorg;
        private $Dtinclusao;
        private $Cdfilial;
        private $Nmfilial;
        private $Cdempresa;
        private $Cdinscmuni;
        private $Cdinscesta;
        private $Idutfilipadr;

        /******************************************** GETTERS AND SETTRES ***********************************************/

        public function setCdempresa($Cdempresa)
        {
            $this->Cdempresa = $Cdempresa;
        }

        public function setCdfilial()
        {
            $this->Cdfilial = \Novocodigo::geraCodigo($this->Nrorg, self::TABELA, 1, 4, false);
        }

        public function setCdinscesta($Cdinscesta)
        {
            $this->Cdinscesta = $Cdinscesta;
        }

        public function setCdinscmuni($Cdinscmuni)
        {
            $this->Cdinscmuni = $Cdinscmuni;
        }

        public function setDtinclusao()
        {
            $this->Dtinclusao = DateUtil::getDataAtual()->format(DateUtil::FORMATO_BRASILEIRO);
        }

        public function setIdcomparqxmlfil($Idcomparqxmlfil)
        {
            $this->Idcomparqxmlfil = $Idcomparqxmlfil;
        }

        public function setIdconsorcfil($Idconsorcfil)
        {
            $this->Idconsorcfil = $Idconsorcfil;
        }

        public function setIdutfilipadr($Idutfilipadr)
        {
            $this->Idutfilipadr = $Idutfilipadr;
        }

        public function setNmfilial($Nmfilial)
        {
            $this->Nmfilial = $Nmfilial;
        }

        public function setNrorg($Nrorg)
        {
            $this->Nrorg = $Nrorg;
        }

        /************************************** CONSTRUTOR *************************************/

        function __construct( $Nrorg, $Nmfilial, $Cdempresa, $Cdinscmuni, $Cdinscesta){
            $this->setCdempresa($Cdempresa);
            $this->setCdinscesta($Cdinscesta);
            $this->setCdinscmuni($Cdinscmuni);
            $this->setNmfilial($Nmfilial);
            $this->setNrorg($Nrorg);
            $this->setDtinclusao();
            $this->setCdfilial();
            $this->setIdcomparqxmlfil('N');
            $this->setIdconsorcfil('S');
            $this->setIdutfilipadr('N');

        }

        /************************************** INSERSOR *********************************************/

        public   function add(){

            try {

                $filial = new \FilialEntity();
                $filial->setCdempresa($this->Cdempresa);
                $filial->setCdfilial($this->Cdfilial);
                $filial->setCdinscesta($this->Cdinscesta);
                $filial->setCdinscmuni($this->Cdinscmuni);
                $filial->setDtinclusao($this->Dtinclusao);
                $filial->setIdcomparqxmlfil($this->Idcomparqxmlfil);
                $filial->setIdconsorcfil($this->Idconsorcfil);
                $filial->setIdutfilipadr($this->Idutfilipadr);
                $filial->setNmfilial($this->Nmfilial);
                $filial->setNrorg($this->Nrorg);

                \Filial::inserirFilial($filial);

                return $this->Cdfilial;

            } catch (\Exception $e) {
                tk_message($e->getMessage(),'error',true);
            }
        }
    }