<?php

namespace Folha\Logic\Epi;

/**
 * Manipulação da imagem do EPI
 *
 * @author ingridmoreira
 */
class ImagemEpi {
    public static function retornaEPI($nrorg, $nrepi){
        $epi = \Folha\Entities\SstEpi::findOneByNrorgAndNrepi($nrorg, $nrepi);
        
        return $epi;        
    }
    
    public static function incluiImagemEPI($nrorg, $nrepi, $nomeImagem){
        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        $message = 'Imagem incluída!';
        try {
            $epi = \Folha\Entities\SstEpi::findOneByNrorgAndNrepi($nrorg, $nrepi);

            if ($epi instanceof \Folha\Entities\SstEpi != false) {
                
                if((($epi->getDsarqimgepi()!= null) && ($epi->getDsarqimgepi()!='')) && ($epi->getDsarqimgepi() !== $nomeImagem)){
                    unlink($epi->getDsarqimgepi());
                    $message = 'Imagem alterada!';
                }
    
                $epi->setDsarqimgepi($nomeImagem);
                $epi->persist();
            }

            $connection = \Setforms2\Shared\Registry::getEntityManager();
            $connection->flush();
            $db->getConn()->commit();
            tk_message($message, 'success');
        } catch (\Exception $e) {
            tk_message('Erro ao incluir imagem', 'warning');
        }       
    }
    
    public static function excluiImagemEPI($nrorg, $nrepi){
        $db = \Setforms2\Runtime\Connection::getInstance();
        $db->getConn()->beginTransaction();
        try {

            $epi = \Folha\Entities\SstEpi::findOneByNrorgAndNrepi($nrorg, $nrepi);

            if ($epi instanceof \Folha\Entities\SstEpi !== false) {
                if (($epi->getDsarqimgepi() != null) && ($epi->getDsarqimgepi() != '')) {
                    $config    = \Setforms2\Shared\Config::getInstance();
                    $dirOrigem = realpath($config->getProjectUpimagensDir());
                    $caminho   = $dirOrigem.DIRECTORY_SEPARATOR.$epi->getDsarqimgepi();
                    unlink($caminho);
                }
                
                $epi->setDsarqimgepi('');
                $epi->persist();
            }
            
            $connection = \Setforms2\Shared\Registry::getEntityManager();
            $connection->flush();
            $db->getConn()->commit();
            tk_message('Imagem Excluída!', 'success');
        } catch (\Exception $e) {
            tk_message('Não foi possível excluir a imagem', 'warning');
        }      
    }
}
